"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.config = void 0;
var fs_1 = require("fs");
var path_1 = require("path");
/**
 * Loads the configuration from package.json or a separate file
 *
 * @returns {Configuration} typefs configuration
 */
function config() {
    var c = process.env.npm_package_config_typefs;
    if (c === undefined) {
        throw new Error('missing path "config.typefs" in package.json.');
    }
    if (c.endsWith('.js')) {
        // eslint-disable-next-line import/no-dynamic-require, global-require
        return require((0, path_1.resolve)(c));
    }
    return JSON.parse((0, fs_1.readFileSync)(c).toString('utf-8'));
}
exports.config = config;
//# sourceMappingURL=config.js.map