"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileDriver = void 0;
var path_1 = require("path");
var fs_1 = require("fs");
var stream_1 = require("stream");
var typefs_registry_1 = require("typefs-registry");
var unlink = fs_1.promises.unlink, rmdir = fs_1.promises.rmdir, stat = fs_1.promises.stat, copyFile = fs_1.promises.copyFile, rename = fs_1.promises.rename, mkdir = fs_1.promises.mkdir;
/**
 * Filesystem storage driver
 */
var FileDriver = /** @class */ (function (_super) {
    __extends(FileDriver, _super);
    function FileDriver(c) {
        var _this = _super.call(this) || this;
        _this.configuration = c;
        // root must be an absolute path
        _this.configuration.root = (0, path_1.resolve)(_this.configuration.root);
        return _this;
    }
    /**
     * Opens file and read full contents of file.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<Buffer>} contents of file
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.read = function (path) {
        var _this = this;
        return new Promise(function (_resolve, _reject) {
            _this.readStream(path)
                .then(function (stream) {
                var buffer = [];
                stream.on('data', function (d) { return buffer.push(d); });
                stream.on('error', _reject);
                stream.on('end', function () { return _resolve(Buffer.concat(buffer)); });
            })
                .catch(_reject);
        });
    };
    /**
     * Opens file and reads the contents of file in chunks.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<Readable>} contents of file
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.readStream = function (path) {
        try {
            return Promise.resolve((0, fs_1.createReadStream)(this.jail(path)));
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Opens file and writes full contents to file.
     *
     * @param {string} path relative to root of disk
     * @param {Buffer} data contents of file
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.write = function (path, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.writeStream(path, stream_1.Readable.from(data))];
            });
        });
    };
    /**
     * Opens file and writes the contents of file in chunks.
     *
     * @param {string} path relative to root of disk
     * @param {Readable} data contents of file
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.writeStream = function (path, data) {
        return __awaiter(this, void 0, void 0, function () {
            var p, dir, stream, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        p = this.jail(path);
                        dir = (0, path_1.dirname)(path);
                        return [4 /*yield*/, this.exists(dir)];
                    case 1:
                        if (!!(_a.sent())) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.createDirectory(dir)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        stream = (0, fs_1.createWriteStream)(p);
                        data.pipe(stream);
                        return [2 /*return*/, Promise.resolve()];
                    case 4:
                        e_1 = _a.sent();
                        return [2 /*return*/, Promise.reject(e_1)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deletes file.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.deleteFile = function (path) {
        try {
            return unlink(this.jail(path));
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Deletes directory.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.deleteDirectory = function (path) {
        try {
            return rmdir(this.jail(path), { recursive: true });
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Creates directory.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.createDirectory = function (path) {
        var _this = this;
        return new Promise(function (_resolve, reject) {
            try {
                mkdir(_this.jail(path), { recursive: true });
                _resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    };
    /**
     * List contents of directory
     *
     * @param {string} path relative to root of disk
     * @param {ListDirectoryOptions} options eg. set recursive to true
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.listContents = function (path, options) {
        var _this = this;
        try {
            var p = this.jail(path);
            var absolutePaths = [];
            if (options === null || options === void 0 ? void 0 : options.recursive) {
                absolutePaths = this.recursiveReadDir(p);
            }
            else {
                absolutePaths = this.filterFiles(p, (0, fs_1.readdirSync)(p, { withFileTypes: true }));
            }
            var relativePaths = absolutePaths.map(function (f) { return f.replace(_this.configuration.root, ''); });
            return Promise.resolve(relativePaths.sort());
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Checks if file or directory exists.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<boolean>} true when path exists
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.exists = function (path) {
        var _this = this;
        return new Promise(function (_resolve) {
            try {
                var jailedPath = _this.jail(path);
                stat(jailedPath)
                    .then(function () { return _resolve(true); })
                    .catch(function () { return _resolve(false); });
            }
            catch (e) {
                _resolve(false);
            }
        });
    };
    /**
     * When was file last modified.
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<Date>} when file was last modified
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.lastModified = function (path) {
        var _this = this;
        return new Promise(function (_resolve, reject) {
            try {
                var jailedPath = _this.jail(path);
                stat(jailedPath)
                    .then(function (s) { return _resolve(new Date(s.mtime)); })
                    .catch(function (e) { return reject(e); });
            }
            catch (e) {
                reject(e);
            }
        });
    };
    /**
     * Size of file
     *
     * @param {string} path relative to root of disk
     * @returns {Promise<number>} The file size in bytes
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.fileSize = function (path) {
        var _this = this;
        return new Promise(function (_resolve, reject) {
            try {
                var p = _this.jail(path);
                stat(p)
                    .then(function (s) { return _resolve(s.size); })
                    .catch(function (e) { return reject(e); });
            }
            catch (e) {
                reject(e);
            }
        });
    };
    /**
     * Moves source file to destination
     *
     * @param {string} source path relative to root of disk
     * @param {string} destination path relative to root of disk
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.move = function (source, destination) {
        try {
            var jailedSource = this.jail(source);
            var jailedDestination = this.jail(destination);
            return rename(jailedSource, jailedDestination);
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Copies source file to destination
     *
     * @param {string} source path relative to root of disk
     * @param {string} destination path relative to root of disk
     * @returns {Promise<void>}
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.copy = function (source, destination) {
        try {
            var jailedSource = this.jail(source);
            var jailedDestination = this.jail(destination);
            return copyFile(jailedSource, jailedDestination);
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Controls access to paths which are above/outside the root directory
     *
     * @param {string} path relative path to disks root directory
     * @returns {string} absolute path
     * @throws Error when path is outside root directory and
     * configuration.jail is set to true
     */
    FileDriver.prototype.jail = function (path) {
        return typefs_registry_1.Util.jail(path, this.configuration.root, this.configuration.jail);
    };
    FileDriver.prototype.recursiveReadDir = function (path) {
        var _this = this;
        var dir = (0, fs_1.readdirSync)(path, { withFileTypes: true });
        var files = this.filterFiles(path, dir);
        dir
            .filter(function (e) { return e.isDirectory(); })
            .map(function (e) { return (0, path_1.join)(path, e.name); })
            .forEach(function (p) {
            files = __spreadArray(__spreadArray([], files, true), _this.recursiveReadDir(p), true);
        });
        return files;
    };
    // eslint-disable-next-line class-methods-use-this
    FileDriver.prototype.filterFiles = function (path, directoryEntities) {
        return directoryEntities
            .filter(function (e) { return e.isFile(); })
            .map(function (e) { return (0, path_1.join)(path, e.name); });
    };
    return FileDriver;
}(typefs_registry_1.DiskDriver));
exports.FileDriver = FileDriver;
//# sourceMappingURL=file-driver.js.map